#Note: multi-line variable uses triple single quotes this is being used because we're wrapping our function into a string...
#so we can write it into a script node that dynamically creates the formatted script job on scene open...
#this is to make the scriptJob persistent and dynamic so we assure it works when referenced
import maya.cmds as cmds
characterChangeCode = '''
#################code v04####################################################################################################
#################Start of code inserted into the expression  script node#####################################################
#################Start of code inserted into the expression  script node#####################################################
import maya.cmds as cmds
#define function that will get called when parameter is changed
def charSwapConfigFn(ns,obj,attr):
	ObjAttr = str(obj+"."+attr)
	print "!!!!!!!!!!running function on "+ObjAttr+"!!!!!!!!!!"
	colorChange = ns+"CharacterMat.color"
	hatVisibility = ns+"Hat.visibility"
	noseVisibility = ns+"Nose.visibility"
	if cmds.getAttr(ObjAttr)==0:
		print "it's the yellow one"
		cmds.setAttr(colorChange, 1, 1, 0, type="double3")
		cmds.setAttr(hatVisibility, 0)
		cmds.setAttr(noseVisibility, 0)
	elif cmds.getAttr(ObjAttr)==1:
		cmds.setAttr(colorChange, 1, 0, 0, type='double3')
		cmds.setAttr(hatVisibility, 0)
		cmds.setAttr(noseVisibility, 1)
		print "it's the red one"
	elif cmds.getAttr(ObjAttr)==2:
		cmds.setAttr(colorChange, 0, 0, 1, type='double3')
		cmds.setAttr(hatVisibility, 1)
		cmds.setAttr(noseVisibility, 0)
		print "it's the blue one"
	elif cmds.getAttr(ObjAttr)==3:
		cmds.setAttr(colorChange, 0, 1, 0, type='double3')
		cmds.setAttr(hatVisibility, 1)
		cmds.setAttr(noseVisibility, 1)
		print "it's the green one"

# define variables 
thisAttribute = "CharacterConfig"
thisObject = "determined below"
thisNamespace = "determined below"

# find all objects with that attribute
unfilteredList = cmds.ls(type="transform")
for obj in unfilteredList:
	print "Checking Object: "+obj
	if cmds.attributeQuery(thisAttribute, n=obj, exists=True):
		thisObject = obj
		#get name with namespace to make sure it still works when referenced
		thisNamespace = ((obj.rpartition(':')[0])+":")
		#call and test function
		charSwapConfigFn(thisNamespace,thisObject,thisAttribute)
		#add below lines of this into a Sciptjob after making sure the above function works on it's own
		fullTarget = (thisObject+"."+thisAttribute)
		cmds.scriptJob(attributeChange=[fullTarget,"charSwapConfigFn(thisNamespace,thisObject,thisAttribute)"])
#################End of code inserted into the expression  script node#####################################################
#################End of code inserted into the expression  script node#####################################################
'''
#Note: multi-line variable uses triple single quotes....
#this is being used because we're wrapping our function into a string...
#get rid of it if it already exists and then remake it to prevent duplicates during editing
if cmds.objExists('scriptNodeCharacterChanged'):cmds.delete('scriptNodeCharacterChanged')
cmds.scriptNode( scriptType=2, beforeScript=characterChangeCode.replace("'''","''" ), name='scriptNodeCharacterChanged', sourceType='python')

